﻿Fluke Calibration                                           MET/CAL Procedure
=============================================================================
INSTRUMENT:            Tek MDO4054B-6: (1 yr) VER /9500+4Hd,EPM,HFSG,LO,SWPG
DATE:                  2018-03-16 12:27:28
AUTHOR:                Fluke
REVISION:              $Revision: 23114 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       134
CONFIGURATION:         Datron 9500 (C5,S6)
CONFIGURATION:         Datron 9510 on channel 1
CONFIGURATION:         Datron 9510 on channel 2
CONFIGURATION:         Datron 9510 on channel 3
CONFIGURATION:         Datron 9510 on channel 4
CONFIGURATION:         Agilent EPM
CONFIGURATION:         Agilent E9304A on channel 1
CONFIGURATION:         High Freq Signal Generator
CONFIGURATION:         Local Oscillator
CONFIGURATION:         Sweep Generator
STANDARD:              Agilent 11667A
=============================================================================
#
#  Procedure Author:
#        DAC, CAD
#
#  Source(s):
#        MDO4000 Series Mixed Domain Oscilloscopes
#        Specifications and Performance Verification Technical Reference
#        PN 077-0583-02
#
#  Flexible Standard(s) Required:
#
#    Two physical generators are required for testing: SWPG and HFSG.  A third
#    flexible alias (LO) must also be configured for the Phase Noise test.  If
#    either the SWPG or HFSG meet the minimum use requirements for Single-
#    Sideband Phase Noise, the LO alias can be added to either.  A third
#    physical generator would only be required if necessary to satisfy the
#    minimum use requirements.
#
#        Synthesized Sweep Generator (SWPG):
#          Frequency Range:       50 kHz to 6 GHz
#          Frequency Accuracy:    ± 5 ppm
#          Amplitude Range:       -15 dBm to +10 dBm
#          Amplitude Resolution:  1 dB
#          Example: R&S SMF100A
#
#        High Frequency Signal Generator (HFSG):
#          Frequency Range:       2 to 4.49 GHz
#          Frequency Accuracy:    5 ppm
#          Amplitude Range:       -2 dBm to 0 dBm
#          Amplitude Resolution:  1 dB
#          Single-Sideband Phase Noise:
#          -  10 kHz offset: < 90 dBc/Hz
#          - 100 kHz offset: < 95 dBc/Hz
#          -   1 MHz offset: < 113 dBc/Hz
#          Example: Anritsu MG3692B, Opt 30 (or 3)
#
#        Local Oscillator (LO):
#          Frequency Range:       2 GHz CW
#          Frequency Accuracy:    5 ppm
#          Amplitude Range:       0 dBm
#          Amplitude Resolution:  1 dB
#          Single-Sideband Phase Noise:
#          -  10 kHz offset: < 90 dBc/Hz
#          - 100 kHz offset: < 95 dBc/Hz
#          -   1 MHz offset: < 113 dBc/Hz
#          Example: Fluke 9640A-LPNX
#
#  Additional Equipment Required:
#
#        Power Splitter (Agilent 11667A):
#          Frequency Range:       DC to 6 GHz
#          Impedance:             50 Ω
#          Equivalent Output SWR:    DC to 4 GHz: < 1.10
#                                 4 GHz to 6 GHz: < 1.20
#          Output Tracking:          DC to 4 GHz: < 0.15 dB
#                                 4 GHz to 6 GHz: < 0.20 dB
#
#  Additional Equipment/Accessories Required (or equivalent):
#
#        Adapters:
#        - Type N (f) to 3.5 mm (f), 50 Ω, DC to 6 GHz
#        - Type N (m) to 3.5 mm (f), 50 Ω, DC to 6 GHz (2 ea.)
#        - BNC Tee (f)-(m)-(f), 50 Ω, 10 MHz
#
#        Cables:
#        - 3.5 mm (m)-(m), 50 Ω, 10 MHz to 6 GHz (2 ea.)
#        - BNC (m)-(m), 50 Ω, 10 MHz, 36" (3 ea.)
#
#        Other:
#        - Tektronix P6516 digital probe
#        - BNC-to-0.1 inch pin adapter
#        - 50 Ω feed through terminator
#        - Power Combiner
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

# These statements are here to force the main procedure header to list the
# configuration required by the subprocedures.
  1.001  IF           0
  1.002  M9500                       CH1
  1.003  9500         500MH                        1Vpp           LS    S  L
  1.004  M9500                       CH2
  1.005  9500         500MH                        1Vpp           LS    S  L
  1.006  M9500                       CH3
  1.007  9500         500MH                        1Vpp           LS    S  L
  1.008  M9500                       CH4
  1.009  9500         500MH                        1Vpp           LS    S  L
  1.010  EPM          Zero_and_Cal; PowerSensorA = E9304A
  1.011  IEEE         [@HFSG]
  1.011  IEEE         [@LO]
  1.012  IEEE         [@SWPG]
  1.013  STD          Agilent 11667A
  1.014  ENDIF

  1.015  MATH         @DUT_Model = "MDO4054B-6"; @NumChan = 4
  1.016  MATH         @Bandwidth = 500E+6; @DUT_MaxFreq = "6 GHz"

  1.017  CALL         Sub Tek MDO40x4 (1 yr) VER /9500+4Hd,EPM,HFSG,LO,SWPG

  1.018  END
