﻿Fluke Calibration                                           MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Initialize /HFSG
INSTRUMENT:            Sub Reset /HFSG
INSTRUMENT:            Sub Output Off /HFSG
INSTRUMENT:            Sub Apply /HFSG
INSTRUMENT:            Sub Get Options /HFSG
INSTRUMENT:            Sub Get Accuracy /HFSG
DATE:                  2013-01-11 09:38:03
AUTHOR:                Fluke
REVISION:              $Revision: 23112 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       7
NUMBER OF LINES:       886
CONFIGURATION:         HF Signal Generator
=============================================================================
#
#  Procedure Author:
#        DAC, DFM, CAD
#
#  Compatibility:
#        MET/CAL 7.2 or later
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
#  Parameters       Values
#  ---------------  ---------------------------------------------------------
#  @HFSG_Freq       <NR3>[][<prefix>]Hz
#
#  @HFSG_Ampl       <NR3>[]dBm | <NR3>[][<prefix>]V | <NR3>[][<prefix>]Vp |
#                   <NR3>[][<prefix>]Vpp
#
#  @HFSG_ModFreq    <NR3>[][<prefix>]Hz
#
#  @HFSG_ModSrc     Int | Ext
#
#  @HFSG_ExtCpl     AC | DC
#
#  @HFSG_AM         On | Off
#
#  @HFSG_AM_Depth   <NR3>[][<prefix>]%
#
#  @HFSG_FM         On | Off
#
#  @HFSG_FM_Dev     <NR3>[][<prefix>]Hz
#
#  @HFSG_PM         On | Off
#
#  @HFSG_PM_Dev     <NR3>[][<prefix>]rad
#
#  @HFSG_PL         On | Off
#
#  @HFSG_PL_Width   <NR3>[][<prefix>]s
#
#  @HFSG_PL_Delay   <NR3>[][<prefix>]s
#
#  @HFSG_PL_Imp     <NR3>[][<prefix>]Ohm
#
#  @HFSG_PL_Slope   Pos | Neg
#
#  @HFSG_PL_Cond    On | Off
#
#  @HFSG_Cond       On | Off
#
#  @HFSG_ROSC *     Int | Ext
#
#  NOTES:
#  * Manual selection prompts for rear panel switches will ONLY be displayed
#    when explicitly requesting "Int" or "Ext".  Leaving @HFSG_ROSC blank
#    after calling Sub Initialize will NOT prompt the operator for a change.
#
#  Example Usage:
#
#      CALL         Sub Initialize /HFSG
#      CALL         Sub Reset /HFSG
#
#      MATH         @HFSG_Freq     = "500 MHz"
#      MATH         @HFSG_Ampl     = "-10 dBm"
#      MATH         @HFSG_ModSrc   = "Int"
#      MATH         @HFSG_ModFreq  = "1 kHz"
#      MATH         @HFSG_AM_Depth = "30%"
#      MATH         @HFSG_AM       = "On"
#      CALL         Sub Apply /HFSG
#
#      CALL         Sub Output Off /HFSG
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  JMPL         INITIALIZE                   PSUBI("Initialize")
  1.002  JMPL         RESET                        PSUBI("Reset")
  1.003  JMPL         OUTPUT_OFF                   PSUBI("Output Off")
  1.004  JMPL         APPLY                        PSUBI("Apply")
  1.005  JMPL         GET_OPTIONS                  PSUBI("Get Options")
  1.006  JMPL         GET_ACCURACY                 PSUBI("Get Accuracy")
  1.007  DISP         Called subprocedure not found!
  1.008  END

  1.009  EVAL   Increment Step Number


# =====  Sub Initialize /HFSG  ==============================================

  2.001  LABEL        INITIALIZE

# Get and store:
#   device name
#   converage factor
#   programming section name for looking up programming codes in .ini file.
#   FSC used for IEEE-488 I/O
#   Connection terminal names

  2.002  MATH         @HFSG_DevName = INSTR("HFSG")

  2.003  IF           0
  2.004  MATH         @HFSG_Conf = CONF(@HFSG_DevName)
  2.005  ENDIF

  2.006  MATH         @HFSG_ProgSecName = RINFE(@HFSG_DevName, "ProgSecName")
  2.007  MATH         @HFSG_FSC     = RINFE(@HFSG_ProgSecName, "FSC")
  2.008  MATH         @HFSG_Output  = RINFE(@HFSG_ProgSecName, "Output50_Ohm")
  2.009  MATH         @HFSG_RefIn   = RINFE(@HFSG_ProgSecName, "RefIn")
  2.010  MATH         @HFSG_RefOut  = RINFE(@HFSG_ProgSecName, "RefOut")

# Initialize parameters to the empty string (unset).
  2.011  MATH         @HFSG_CPT      = ""
  2.012  MATH         @HFSG_Freq     = ""
  2.013  MATH         @HFSG_Ampl     = ""
  2.014  MATH         @HFSG_ModFreq  = ""
  2.015  MATH         @HFSG_ModSrc   = ""
  2.016  MATH         @HFSG_ExtCpl   = ""
  2.017  MATH         @HFSG_AM       = ""
  2.018  MATH         @HFSG_AM_Depth = ""
  2.019  MATH         @HFSG_FM       = ""
  2.020  MATH         @HFSG_FM_Dev   = ""
  2.021  MATH         @HFSG_PM       = ""
  2.022  MATH         @HFSG_PM_Dev   = ""
  2.023  MATH         @HFSG_PL       = ""
  2.024  MATH         @HFSG_PL_Width = ""
  2.025  MATH         @HFSG_PL_Delay = ""
  2.026  MATH         @HFSG_PL_Imp   = ""
  2.027  MATH         @HFSG_PL_Slope = ""
  2.028  MATH         @HFSG_PL_Cond  = ""
  2.029  MATH         @HFSG_Cond     = ""
  2.030  MATH         @HFSG_ROSC     = ""

# Check for the flag that triggers operator message to manually select
# frequency reference source.  Initialize variable if does not exist, else
# retain existing switch position.
  2.031  IF           NOT(ISVAR("@HFSG_ROSC_Set"))
  2.032  MATH         @HFSG_ROSC_Set = ""
  2.033  ENDIF

# Check for options that affect accuracy lookup.
  2.034  CALL         Sub Get Options /HFSG

# Get programming string for RESET FSC.
  2.035  MATH         ResetCmd = RINF(@HFSG_ProgSecName, "ResetFSC")

# If RESET_FSC is defined, establish the RESET FSC.
  2.036  IF           NOT(EMPTY(ResetCmd))

  2.037  IF           ZCMPI(ResetCmd, "[SDC]")
  2.038  RESET        [@HFSG][SDC]
  2.039  ELSE
  2.040  RESET        [@HFSG][V ResetCmd]
  2.041  ENDIF

  2.042  ENDIF

  2.043  END

  2.044  EVAL   Increment Step Number


# =====  Sub Reset /HFSG  ===================================================

  3.001  LABEL        RESET

  3.002  MATH         @HFSG_Cmd = RINFE(@HFSG_ProgSecName, "Reset")
  3.003  CALL         Sub Send Command /HFSG
  3.004  END

  3.005  EVAL   Increment step number


# =====  Sub Output Off /HFSG  ==============================================

  4.001  LABEL        OUTPUT_OFF

  4.002  MATH         @HFSG_Cmd = RINF(@HFSG_ProgSecName, "OutputOff")

# If "Output_Off" is defined, send the command.
  4.003  IF           NOT(EMPTY(@HFSG_Cmd))
  4.004  CALL         Sub Send Command /HFSG
  4.005  ENDIF

  4.006  END

  4.007  EVAL   Increment step number


# =====  Sub Apply /HFSG  ===================================================

  5.001  LABEL        APPLY

# -----  Frequency  -------------------------------

# Get the command string.
  5.002  MATH         FreqCmd = RINFE(@HFSG_ProgSecName, "Freq")
# Convert to base units and insert in programming string.
  5.003  MATH         @HFSG_Cmd = REPL("<val>", BASE(@HFSG_Freq), FreqCmd)
  5.004  CALL         Sub Send Command /HFSG

# -----  Amplitude  -------------------------------

  5.005  MATH         Ampl = BASE(@HFSG_Ampl); AmplUnits = UNIT(@HFSG_Ampl)
  5.006  MATH         AmplCmd = ""

  5.007  IF           ZCMPI(AmplUnits, "dBm")

# Use discrete command for negative dBm, if one exists.
  5.008  IF           Ampl < 0
  5.009  MATH         AmplCmd = RINF(@HFSG_ProgSecName, "Ampl_dBmNeg")
# Otherwise use discrete command for positive dBm, if one exists.
  5.010  ELSE
  5.011  MATH         AmplCmd = RINF(@HFSG_ProgSecName, "Ampl_dBmPos")
  5.012  ENDIF

# Otherwise use the general command.
  5.013  IF           EMPTY(AmplCmd)
  5.014  MATH         AmplCmd = RINFE(@HFSG_ProgSecName, "Ampl_dBm")
  5.015  ELSEIF       Ampl < 0
  5.016  MATH         Ampl = ABS(Ampl)
  5.017  ENDIF

  5.018  ELSEIF       ZCMPI(AmplUnits, "V")
  5.019  MATH         AmplCmd = RINFE(@HFSG_ProgSecName, "Ampl_Vrms")
  5.020  ELSEIF       ZCMPI(AmplUnits, "Vp")
  5.021  MATH         AmplCmd = RINF(@HFSG_ProgSecName, "Ampl_Vp")

# If there is no Vp command see if there is a Vpp command.
  5.022  IF           EMPTY(AmplCmd)
  5.023  MATH         AmplCmd = RINFE(@HFSG_ProgSecName, "Ampl_Vpp")
  5.024  ELSE
# Convert Vp to Vpp.
  5.025  MATH         Ampl = Ampl * 2
  5.026  ENDIF

  5.027  ELSEIF       ZCMPI(AmplUnits, "Vpp")
  5.028  MATH         AmplCmd = RINF(@HFSG_ProgSecName, "Ampl_Vpp")

# If there is no Vpp command see if there is a Vp command.
  5.029  IF           EMPTY(AmplCmd)
  5.030  MATH         AmplCmd = RINFE(@HFSG_ProgSecName, "Ampl_Vp")
  5.031  ELSE
# Convert Vpp to Vp.
  5.032  MATH         Ampl = Ampl / 2
  5.033  ENDIF

  5.034  ENDIF

  5.035  MATH         @HFSG_Cmd = REPL("<val>", Ampl, AmplCmd)
  5.036  CALL         Sub Send Command /HFSG

# -----  AM  --------------------------------------

  5.037  IF           NOT(EMPTY(@HFSG_AM))

# -----  Modulation Source
  5.038  IF           NOT(EMPTY(@HFSG_ModSrc))

  5.039  IF           ZCMPI(@HFSG_ModSrc, "Int")

# For devices where internal modulation source and frequency are programmed
# with a single command, postpone programming these settings to the mod
# frequency block below.
  5.040  IF           NOT(EMPTY(RINF(@HFSG_ProgSecName, "AM_Int400Hz")))
  5.041  MATH         ModSrc = ""
  5.042  ELSEIF       NOT(EMPTY(RINF(@HFSG_ProgSecName, "AM_Int1kHz")))
  5.043  MATH         ModSrc = ""
  5.044  ELSE
  5.045  MATH         ModSrc = "AM_Int"
  5.046  ENDIF

  5.047  ELSE         ; External Coupling

  5.048  IF           ZCMPI(@HFSG_ExtCpl, "AC")
  5.049  MATH         ModSrc = "AM_ExtAC"
  5.050  ELSEIF       ZCMPI(@HFSG_ExtCpl, "DC")
  5.051  MATH         ModSrc = "AM_ExtDC"
  5.052  ELSE
  5.053  MATH         ModSrc = "AM_Ext"
  5.054  ENDIF

  5.055  ENDIF        ; ZCMPI(@HFSG_ModSrc, "Int")

  5.056  IF           NOT(EMPTY(ModSrc))
  5.057  MATH         @HFSG_Cmd = RINFE(@HFSG_ProgSecName, ModSrc)
  5.058  CALL         Sub Send Command /HFSG
  5.059  ENDIF

  5.060  ENDIF        ; IF Modulation Source

# -----  Modulation Frequency.
  5.061  IF           NOT(EMPTY(@HFSG_ModFreq))
  5.062  MATH         ModFreq = BASE(@HFSG_ModFreq); ModFreqCmd = ""

# Use discrete command for 400 Hz Mod. Freq., if one exists.
  5.063  IF           ModFreq == 400
  5.064  MATH         ModFreqCmd = RINF(@HFSG_ProgSecName, "AM_Int400Hz")
# Otherwise use discrete command for 1 kHz Mod. Freq, if one exists.
  5.065  ELSEIF       ModFreq == 1E+3
  5.066  MATH         ModFreqCmd = RINF(@HFSG_ProgSecName, "AM_Int1kHz")
  5.067  ENDIF

# Otherwise use the general command.
  5.068  IF           EMPTY(ModFreqCmd)
  5.069  MATH         ModFreqCmd = RINFE(@HFSG_ProgSecName, "AM_ModFreq")
  5.070  MATH         @HFSG_Cmd  = REPL("<val>", ModFreq, ModFreqCmd)
  5.071  ELSE
  5.072  MATH         @HFSG_Cmd  = ModFreqCmd
  5.073  ENDIF

  5.074  CALL         Sub Send Command /HFSG
  5.075  ENDIF        ; IF Modulation Frequency

# -----  AM Depth
  5.076  IF           NOT(EMPTY(@HFSG_AM_Depth))
  5.077  MATH         AMDepth    = BASE(@HFSG_AM_Depth)
  5.078  MATH         AMDepthCmd = RINF(@HFSG_ProgSecName, "AM_Depth")
  5.079  MATH         @HFSG_Cmd  = REPL("<val>", AMDepth, AMDepthCmd)
  5.080  CALL         Sub Send Command /HFSG
  5.081  ENDIF

# Get the AM ON programming command string.
  5.082  MATH         @HFSG_Cmd = RINF(@HFSG_ProgSecName, "AM_On")

  5.083  IF           NOT(EMPTY(@HFSG_Cmd))
  5.084  CALL         Sub Send Command /HFSG
  5.085  ENDIF

  5.086  ENDIF        ; IF AM

# -----  FM  --------------------------------------

  5.087  IF           NOT(EMPTY(@HFSG_FM))

# -----  Modulation source.
  5.088  IF           NOT(EMPTY(@HFSG_ModSrc))

  5.089  IF           ZCMPI(@HFSG_ModSrc, "Int")

# See comments in AM Modulation source, above.
  5.090  IF           NOT(EMPTY(RINF(@HFSG_ProgSecName, "FM_Int400Hz")))
  5.091  MATH         ModSrc = ""
  5.092  ELSEIF       NOT(EMPTY(RINF(@HFSG_ProgSecName, "FM_Int1kHz")))
  5.093  MATH         ModSrc = ""
  5.094  ELSE
  5.095  MATH         ModSrc = "FM_Int"
  5.096  ENDIF

  5.097  ELSE         ; External Coupling

  5.098  IF           ZCMP(@HFSG_ExtCpl, "AC")
  5.099  MATH         ModSrc = "FM_ExtAC"
  5.100  ELSEIF       ZCMP(@HFSG_ExtCpl, "DC")
  5.101  MATH         ModSrc = "FM_ExtDC"
  5.102  ELSE
  5.103  MATH         ModSrc = "FM_Ext"
  5.104  ENDIF

  5.105  ENDIF

  5.106  IF           NOT(EMPTY(ModSrc))
  5.107  MATH         @HFSG_Cmd = RINFE(@HFSG_ProgSecName, ModSrc)
  5.108  CALL         Sub Send Command /HFSG
  5.109  ENDIF

  5.110  ENDIF        ; IF Modulation Source

# -----  Modulation Frequency.
  5.111  IF           NOT(EMPTY(@HFSG_ModFreq))
  5.112  MATH         ModFreq = BASE(@HFSG_ModFreq); ModFreqCmd = ""

# Use discrete command for 400 Hz Mod. Freq., if one exists.
  5.113  IF           ModFreq == 400
  5.114  MATH         ModFreqCmd = RINF(@HFSG_ProgSecName, "FM_Int400Hz")
# Otherwise use discrete command for 1 kHz Mod. Freq., if one exists.
  5.115  ELSEIF       ModFreq == 1E+3
  5.116  MATH         ModFreqCmd = RINF(@HFSG_ProgSecName, "FM_Int1kHz")
  5.117  ENDIF

# Otherwise use the general command.
  5.118  IF           EMPTY(ModFreqCmd)
  5.119  MATH         ModFreqCmd = RINFE(@HFSG_ProgSecName, "FM_ModFreq")
  5.120  MATH         @HFSG_Cmd = REPL("<val>", ModFreq, ModFreqCmd)
  5.121  ENDIF

  5.122  CALL         Sub Send Command /HFSG
  5.123  ENDIF        ; IF Modulation Frequency

# -----  FM Deviation
  5.124  IF           NOT(EMPTY(@HFSG_FM_Dev))
  5.125  MATH         FMDevCmd = RINFE(@HFSG_ProgSecName, "FM_Dev")
  5.126  MATH         @HFSG_Cmd = REPL("<val>", BASE(@HFSG_FM_Dev), FMDevCmd)
  5.127  CALL         Sub Send Command /HFSG
  5.128  ENDIF

# FM On programming command string.
  5.129  MATH         @HFSG_Cmd = RINF(@HFSG_ProgSecName, "FM_ON")

  5.130  IF           NOT(EMPTY(@HFSG_Cmd))
  5.131  CALL         Sub Send Command /HFSG
  5.132  ENDIF

  5.133  ENDIF        ; IF FM

# -----  Phase Modulation  ------------------------

  5.134  IF           NOT(EMPTY(@HFSG_PM))

# -----  Modulation Source
  5.135  IF           NOT(EMPTY(@HFSG_ModSrc))

  5.136  IF           ZCMPI(@HFSG_ModSrc, "Int")
  5.137  MATH         ModSrc = "PM_Int"
  5.138  ELSE

  5.139  IF           ZCMP(@HFSG_ExtCpl, "AC")
  5.140  MATH         ModSrc = "PM_ExtAC"
  5.141  ELSEIF       ZCMP(@HFSG_ExtCpl, "DC")
  5.142  MATH         ModSrc = "PM_ExtDC"
  5.143  ELSE
  5.144  MATH         ModSrc = "PM_Ext"
  5.145  ENDIF

  5.146  ENDIF

  5.147  MATH         @HFSG_Cmd = RINFE(@HFSG_ProgSecName, ModSrc)
  5.148  CALL         Sub Send Command /HFSG
  5.149  ENDIF        ; IF Modulation Source

# -----  Modulation Frequency
  5.150  IF           NOT(EMPTY(@HFSG_ModFreq))
  5.151  MATH         ModFreq = BASE(@HFSG_ModFreq); ModFreqCmd = ""

# Use discrete command for 400 Hz Mod. Freq., if one exists.
  5.152  IF           ModFreq == 400
  5.153  MATH         ModFreqCmd = RINF(@HFSG_ProgSecName, "PM_Int400Hz")
# Otherwise use discrete command for 1 kHz Mod. Freq., if one exists.
  5.154  ELSEIF       ModFreq == 1E+3
  5.155  MATH         ModFreqCmd = RINF(@HFSG_ProgSecName, "PM_Int1kHz")
  5.156  ENDIF

# Otherwise use the general command.
  5.157  IF           EMPTY(ModFreqCmd)
  5.158  MATH         ModFreqCmd = RINFE(@HFSG_ProgSecName, "PM_ModFreq")
  5.159  MATH         @HFSG_Cmd = REPL("<val>", ModFreq, ModFreqCmd)
  5.160  ENDIF

  5.161  CALL         Sub Send Command /HFSG
  5.162  ENDIF        ; IF Modulation Frequency

# -----  Phase Deviation
  5.163  IF           NOT(EMPTY(@HFSG_PM_Dev))
  5.164  MATH         PMDevCmd = RINFE(@HFSG_ProgSecName, "PM_Dev")
  5.165  MATH         @HFSG_Cmd = REPL("<val>", BASE(@HFSG_PM_Dev), PMDevCmd)
  5.166  CALL         Sub Send Command /HFSG
  5.167  ENDIF

# Get the Phase Modulation On programming command string.
  5.168  MATH         @HFSG_Cmd = RINF(@HFSG_ProgSecName, "PM_ON")

  5.169  IF           NOT(EMPTY(@HFSG_Cmd))
  5.170  CALL         Sub Send Command /HFSG
  5.171  ENDIF

  5.172  ENDIF        ; IF PM

# -----  Pulse Modulation  ------------------------

  5.173  IF           NOT(EMPTY(@HFSG_PL))

# -----  Modulation Source
  5.174  IF           NOT(EMPTY(@HFSG_ModSrc))
# Check modulation source selection capability.
  5.175  MATH         PL_SrcSel = RINF(@HFSG_ProgSecName, "PL_SourceSelect")

  5.176  IF           ZCMPI(PL_SrcSel, "Programmable")

  5.177  IF           ZCMPI(@HFSG_ModSrc, "Int")
  5.178  MATH         ModSrc = "PL_Int"
  5.179  ELSE
  5.180  MATH         ModSrc = "PL_Ext"
  5.181  ENDIF

  5.182  MATH         @HFSG_Cmd = RINFE(@HFSG_ProgSecName, ModSrc)
  5.183  CALL         Sub Send Command /HFSG

  5.184  ELSEIF       ZCMPI(PL_SrcSel, "Fixed")
  5.185  MATH         PL_FxdSource = RINFE(@HFSG_ProgSecName, "PL_Source")

  5.186  IF           NOT(ZCMPI(PL_FxdSource, @HFSG_ModSrc))
  5.187  DISP         The required Pulse Modulation Source ([V @HFSG_ModSrc])
  5.187  DISP         capability is not supported for the configured
  5.187  DISP         [V @HFSG_DevName].
  5.187  DISP
  5.187  DISP         [V @HFSG_DevName] only supports fixed ([V PL_FxdSource])
  5.187  DISP         source for pulse modulation.  The calling procedure
  5.187  DISP         requires an "[V @HFSG_ModSrc]" source.
  5.187  DISP
  5.187  DISP         Select "Terminate" to abort this procedure, configure
  5.187  DISP         a suitable HFSG model, then restart this procedure.
  5.188  END
  5.189  ENDIF

  5.190  ELSE
  5.191  DISP         The required Pulse Modulation Source ([V @HFSG_ModSrc])
  5.191  DISP         capability is not supported for the configured
  5.191  DISP         [V @HFSG_DevName].
  5.191  DISP
  5.191  DISP         This may be due to a lack of hardware capability, or
  5.191  DISP         lack of support within user_config_instr.ini.
  5.191  DISP
  5.191  DISP         Select "Terminate" to abort this procedure.  Either
  5.191  DISP         configure a suitable HFSG model or add the required
  5.191  DISP         parameters to user_config_instr.ini, then restart this
  5.191  DISP         procedure.
  5.192  END
  5.193  ENDIF        ; PL Source Selection

  5.194  ENDIF        ; NOT(EMPTY(@HFSG_ModSrc))

# -----  Modulation Frequency
  5.195  IF           NOT(EMPTY(@HFSG_ModFreq))
  5.196  MATH         ModFreq = BASE(@HFSG_ModFreq); ModFreqCmd = ""

# Use discrete command for 400 Hz Mod. Freq., if one exists.
  5.197  IF           ModFreq == 400
  5.198  MATH         ModFreqCmd = RINF(@HFSG_ProgSecName, "PL_Int400Hz")
# Otherwise use discrete command for 1 kHz Mod. Freq., if one exists.
  5.199  ELSEIF       ModFreq == 1E+3
  5.200  MATH         ModFreqCmd = RINF(@HFSG_ProgSecName, "PL_Int1kHz")
  5.201  ENDIF

# Otherwise use the general Mod. Freq. command.
  5.202  IF           EMPTY(ModFreqCmd)
  5.203  MATH         ModFreqCmd = RINFE(@HFSG_ProgSecName, "PL_ModFreq")
  5.204  MATH         @HFSG_Cmd = REPL("<val>", ModFreq, ModFreqCmd)
  5.205  ENDIF

  5.206  CALL         Sub Send Command /HFSG
  5.207  ENDIF        ; IF Modulation Frequency

# -----  Pulse Width
  5.208  IF           NOT(EMPTY(@HFSG_PL_Width))
  5.209  MATH         PLWidthCmd = RINFE(@HFSG_ProgSecName, "PL_Width")
  5.210  MATH         PLWidth = BASE(@HFSG_PL_Width)
  5.211  MATH         @HFSG_Cmd = REPL("<val>", PLWidth, PLWidthCmd)
  5.212  CALL         Sub Send Command /HFSG
  5.213  ENDIF

# -----  Pulse Delay
  5.214  IF           NOT(EMPTY(@HFSG_PL_Delay))
  5.215  MATH         PLDelayCmd = RINFE(@HFSG_ProgSecName, "PL_Delay")
  5.216  MATH         PLDelay = BASE(@HFSG_PL_Delay)
  5.217  MATH         @HFSG_Cmd = REPL("<val>", PLDelay, PLDelayCmd)
  5.218  CALL         Sub Send Command /HFSG
  5.219  ENDIF

# -----  Pulse Impedance
  5.220  IF           NOT(EMPTY(@HFSG_PL_Imp))
  5.221  MATH         PLImpCmd = RINF(@HFSG_ProgSecName, "PL_Imp")
  5.222  MATH         PLImp = BASE(@HFSG_PL_Imp)
  5.223  MATH         @HFSG_Cmd = REPL("<val>", PLImp, PLImpCmd)
  5.224  CALL         Sub Send Command /HFSG
  5.225  ENDIF        ; IF Pulse Impedance

# -----  Pulse Slope
  5.226  IF           NOT(EMPTY(@HFSG_PL_Slope))

  5.227  IF           ZCMPI(@HFSG_PL_Slope, "Pos")
  5.228  MATH         PLSlope = "PL_SlopePos"
  5.229  ELSE
  5.230  MATH         PLSlope = "PL_SlopeNeg"
  5.231  ENDIF

  5.232  MATH         @HFSG_Cmd = RINFE(@HFSG_ProgSecName, PLSlope)
  5.233  CALL         Sub Send Command /HFSG
  5.234  ENDIF

# -----  Pulse Conditioning
  5.235  IF           NOT(EMPTY(@HFSG_PL_Cond))

  5.236  IF           ZCMPI(@HFSG_PL_Cond, "On")
  5.237  MATH         PLCond = "PL_CondOn"
  5.238  ELSE
  5.239  MATH         PLCond = "PL_CondOff"
  5.240  ENDIF

  5.241  MATH         @HFSG_Cmd = RINFE(@HFSG_ProgSecName, PLCond)
  5.242  CALL         Sub Send Command /HFSG
  5.243  ENDIF

# Get the Pulse Modulation On programming command string.
  5.244  MATH         @HFSG_Cmd = RINF(@HFSG_ProgSecName, "PL_ON")

  5.245  IF           NOT(EMPTY(@HFSG_Cmd))
  5.246  CALL         Sub Send Command /HFSG
  5.247  ENDIF

  5.248  ENDIF        ; NOT(EMPTY(@HFSG_PL))

# -----  Reference Oscillator  --------------------

  5.249  IF           NOT(EMPTY(@HFSG_ROSC))

  5.250  IF           ZCMPI(@HFSG_ROSC, "Int")
  5.251  MATH         RefOsc = "RefOscInt"
  5.252  ELSE
  5.253  MATH         RefOsc = "RefOscExt"
  5.254  ENDIF

  5.255  MATH         RefSelect = RINF(@HFSG_ProgSecName, "RefSelect")

  5.256  IF           ZCMPI(RefSelect, "Manual")

# Only prompt for switch selection when the desired setting does not match the
# current setting.
  5.257  IF           NOT(ZCMPI(@HFSG_ROSC, @HFSG_ROSC_Set))
  5.258  MATH         Switch  = RINFE(@HFSG_ProgSecName, "RefOscSwitch")
  5.259  MATH         Setting = RINFE(@HFSG_ProgSecName, RefOsc)
  5.260  DISP         Set [V @HFSG_DevName] [V Switch] switch to [V Setting].
  5.260  DISP         [7][D250][7][D250][7][D250][7][D250][7]
  5.261  MATH         @HFSG_ROSC_Set = @HFSG_ROSC
  5.262  ENDIF        ; Prompt to set Reference Oscillator switch

  5.263  ELSEIF       ZCMPI(RefSelect, "Auto")
# Automatic selection by DUT, nothing to do here.

  5.264  ELSE         ; Programmable
  5.265  MATH         @HFSG_Cmd = RINFE(@HFSG_ProgSecName, RefOsc)
  5.266  CALL         Sub Send Command /HFSG
  5.267  ENDIF

  5.268  ENDIF        ; IF Reference Oscillator

# -----  Output On  -------------------------------

  5.269  MATH         @HFSG_Cmd = RINF(@HFSG_ProgSecName, "OutputOn")

# If "Output_On" is defined, send the command.
  5.270  IF           NOT(EMPTY(@HFSG_Cmd))
  5.271  CALL         Sub Send Command /HFSG
  5.272  ENDIF

  5.273  END

  5.274  EVAL   Increment step number


# =====  Sub Get Options /HFSG  =============================================

  6.001  LABEL        GET_OPTIONS

# Check for the variable flag that indicates whether options have previously
# been configured.  This flag will prevent the driver from asking for option
# configuration more than once.  Initialize variable if it does not exist.
  6.002  IF           NOT(ISVAR("@HFSG_Opt_Set"))
  6.003  MATH         @HFSG_FreqOpt = ""; @HFSG_AmplOpt = ""

# Check for Fluke 6080A/82A fitted options.
  6.004  MATH         F608x = FINDI(@HFSG_DevName, "6080", 1)
  6.005  MATH         F608x = FINDI(@HFSG_DevName, "6082", 1) || F608x

  6.006  IF           F608x
  6.007  OPBR         -z The Fluke 6080A/82A Synthesized RF Signal Generators
  6.007  OPBR         Sweepers may include Options -130 or -132 that affect
  6.007  OPBR         its frequency specifications.
  6.007  OPBR
  6.007  OPBR         Does the configured unit have either Option -130 or
  6.007  OPBR         Option -132 fitted?
  6.007  OPBR         [7][D250][7][D250][7][D250][7][D250][7]

  6.008  IF           MEM1
  6.009  OPBR         -z Does the configured unit have Option -130 fitted?

  6.010  IF           MEM1
  6.011  MATH         @HFSG_FreqOpt = "130"
  6.012  ELSE
  6.013  MATH         @HFSG_FreqOpt = "132"
  6.014  ENDIF

  6.015  ENDIF

  6.016  ENDIF        ; F608x

# Check for HP 8340/8341 fitted options.
  6.017  MATH         HP834x = FINDI(@HFSG_DevName, "8340", 1)
  6.018  MATH         HP834x = FINDI(@HFSG_DevName, "8341", 1) || HP834x

  6.019  IF           HP834x
  6.020  OPBR         -z The HP 8340/8341 Synthesized Sweepers may include
  6.020  OPBR         Options 001, 004, or 005 that affects amplitude
  6.020  OPBR         specifications. (The above options are mutually
  6.020  OPBR         exclusive.)
  6.020  OPBR
  6.020  OPBR         Does the configured unit have any of the above
  6.020  OPBR         options fitted?
  6.020  OPBR         [7][D250][7][D250][7][D250][7][D250][7]

  6.021  IF           MEM1

  6.022  DO
  6.023  MEMI         Enter the fitted option number (001, 004, 005):
# Format option correctly for use in mode string.
  6.024  MATH         Opt = FMT(MEM, "%03.0f")
  6.025  UNTIL        (MEM == 1) || (MEM == 4) || (MEM == 5)

  6.026  MATH         @HFSG_AmplOpt = Opt
  6.027  ENDIF

  6.028  ENDIF        ; HP834x

# Check for all HP/Agilent models which have different amplitude accuracy
# when equipped with Option 001.
  6.029  MATH         Opt001_A = FINDI(@HFSG_DevName, "83620", 1)
  6.030  MATH         Opt001_A = FINDI(@HFSG_DevName, "83622", 1) || Opt001_A
  6.031  MATH         Opt001_A = FINDI(@HFSG_DevName, "83623", 1) || Opt001_A
  6.032  MATH         Opt001_A = FINDI(@HFSG_DevName, "83624", 1) || Opt001_A
  6.033  MATH         Opt001_A = FINDI(@HFSG_DevName, "83630", 1) || Opt001_A
  6.034  MATH         Opt001_A = FINDI(@HFSG_DevName, "83640", 1) || Opt001_A
  6.035  MATH         Opt001_A = FINDI(@HFSG_DevName, "83650", 1) || Opt001_A

  6.036  IF           Opt001_A
  6.037  IEEE         [@HFSG]*OPT?[I$]

  6.038  IF           FINDI(MEM2, "001", 1)
  6.039  MATH         @HFSG_AmplOpt = "001"
  6.040  ENDIF

  6.041  ENDIF        ; Opt001_A

# Check for HP 8648A/B/C/D fitted options.
  6.042  IF           FINDI(@HFSG_DevName, "8648", 1)
  6.043  OPBR         -z The HP 8648A/B/C/D Synthesized Signal Generators
  6.043  OPBR         may include Option 1E5 that affects frequency
  6.043  OPBR         specifications.
  6.043  OPBR
  6.043  OPBR         Does the configured unit have Option 1E5 fitted?
  6.043  OPBR         [7][D250][7][D250][7][D250][7][D250][7]

  6.044  IF           MEM1
  6.045  MATH         @HFSG_FreqOpt = "1E5"
  6.046  ENDIF

  6.047  ENDIF

# Check for all HP/Agilent models which have different frequency accuracy
# when equipped with Option 001.
  6.048  MATH         Opt001_F = FINDI(@HFSG_DevName, "8656", 1)
  6.049  MATH         Opt001_F = FINDI(@HFSG_DevName, "8657", 1) || Opt001_F

  6.050  IF           Opt001_F
  6.051  OPBR         -z The [V @HFSG_DevName] may include Option 001,
  6.051  OPBR         which affects frequency specifications.
  6.051  OPBR
  6.051  OPBR         Does the configured unit have Option 001 fitted?
  6.051  OPBR         [7][D250][7][D250][7][D250][7][D250][7]

  6.052  IF           MEM1
  6.053  MATH         @HFSG_FreqOpt = "001"
  6.054  ENDIF

  6.055  ENDIF        ; Opt001_F

# Check for R&S SMF100A fitted options.
  6.056  IF           FINDI(@HFSG_DevName, "SMF100A", 1)
  6.057  SCPI         [@HFSG]*OPT?[I$]

  6.058  IF           FINDI(MEM2, "SMF-B1,", 0)
  6.059  MATH         @HFSG_FreqOpt = "SMF-B1"
  6.060  ENDIF

  6.061  ENDIF        ; SMF100A

# Set flag indicating that options have already been configured.
  6.062  MATH         @HFSG_Opt_Set = 1
  6.063  ENDIF        ; NOT(@HFSG_Opt_Set)

  6.064  END

  6.065  EVAL   Increment Step Number


# =====  Sub Get Accuracy /HFSG  ============================================

  7.001  LABEL        GET_ACCURACY

# -----  Cardinal Point: Frequency  ---------------
  7.002  IF           ZCMPI(@HFSG_CPT, "Freq")
# Specify Nominal value of parameter.
  7.003  MATH         @HFSG_Nominal = @HFSG_Freq
# Specify third and fourth ACCV2 arguments (frequency and amplitude).
  7.004  MATH         FreqBase = BASE(@HFSG_Freq)
  7.005  MATH         AmplBase = BASE(@HFSG_Ampl)
# Specify HFSG frequency mode string in ModeStr from ini file.
  7.006  MATH         ModeStr = RINFE(@HFSG_DevName, "ModeStringFreq")

# Check for option that affects accuracy.
  7.007  IF           NOT(EMPTY(@HFSG_FreqOpt))
# Append option to mode string.
  7.008  MATH         ModeStr = ModeStr & " " & @HFSG_FreqOpt
  7.009  ENDIF        ; Options

# Retrieve HFSG frequency accuracy.
  7.010  MATH         Acc = ACCV2(@HFSG_DevName, ModeStr, FreqBase, AmplBase)

# -----  Cardinal Point: Amplitude  ---------------
  7.011  ELSEIF       ZCMPI(@HFSG_CPT, "Ampl")
  7.012  MATH         @HFSG_Nominal = @HFSG_Ampl
  7.013  MATH         FreqBase = BASE(@HFSG_Freq)
  7.014  MATH         AmplBase = BASE(@HFSG_Ampl)
  7.015  MATH         ModeStr = RINFE(@HFSG_DevName, "ModeStringAmpl")

  7.016  IF           NOT(EMPTY(@HFSG_AmplOpt))
  7.017  MATH         ModeStr = ModeStr & " " & @HFSG_AmplOpt
  7.018  ENDIF        ; Options

  7.019  MATH         Acc = ACCV2(@HFSG_DevName, ModeStr, AmplBase, FreqBase)

# -----  Cardinal Point: Flatness  ----------------
  7.020  ELSEIF       ZCMPI(@HFSG_CPT, "Flat")

  7.021  MATH         @HFSG_Nominal = @HFSG_Ampl
  7.022  MATH         FreqBase = BASE(@HFSG_Freq)
  7.023  MATH         AmplBase = BASE(@HFSG_Ampl)
  7.024  MATH         ModeStr = RINFE(@HFSG_DevName, "ModeStringFlat")

  7.025  IF           NOT(EMPTY(@HFSG_AmplOpt))
  7.026  MATH         ModeStr = ModeStr & " " & @HFSG_AmplOpt
  7.027  ENDIF        ; Options

  7.028  MATH         Acc = ACCV2(@HFSG_DevName, ModeStr, AmplBase, FreqBase)

  7.029  ENDIF        ; Cardinal point parameters.

# Get value of VSET parameter, confidence value.
  7.030  MATH         Confidence = VGET("CONF")

# VGET query returns empty string if CONF is set to default (2).
  7.031  IF           EMPTY(Confidence)
  7.032  MATH         Confidence = 2
  7.033  ENDIF

  7.034  MATH         Acc = (Acc / CONF(@HFSG_DevName)) * Confidence

# Convert to specified units of ACC nominal (e.g. GHz).
  7.035  MATH         @HFSG_Acc = Acc / PSCALE(@HFSG_Nominal)

  7.036  END
