﻿Fluke Calibration                                           MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Tek MDO4000 (1 yr) Lvl Meas Unc Test VISA /EPM,SWPG
INSTRUMENT:            Sub Tek MDO4000B (1 yr) Abs Amplitude VISA /EPM,SWPG
DATE:                  2018-03-16 12:28:27
AUTHOR:                Fluke
REVISION:              $Revision: 23114 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       100
CONFIGURATION:         Agilent EPM
CONFIGURATION:         Agilent E9304A on channel 1
CONFIGURATION:         Sweep Generator
STANDARD:              Agilent 11667A
=============================================================================
#
#  Procedure Author:
#        CAD
#
#  Models covered:
#        MDO4014-3, MDO4034-3, MDO4054-3, MDO4054-6, MDO4104-3, MDO4104-6
#
#  Compatibility:
#        MET/CAL version 7.3.38 or later
#
#  Additional Equipment Required:
#        Cable, Type N (m)-(m), 50 Ω, 36", DC to 6 GHz
#        Cable, BNC (m)-(m), 50 Ω, 36", 10 MHz
#        Adapter, Type N (m)-(m), DC to 6 GHz
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

# These statements are here to force the procedure header to list the
# instrument configuration required by the subprocedures.
  1.001  IF           0
  1.002  IEEE         [@SWPG]
  1.003  ENDIF

  1.004  STD          Agilent 11667A
  1.005  MATH         @Splitter = "Agilent 11667A"

  1.006  CALL         Sub Initialize /SWPG
  1.007  CALL         Sub Reset /SWPG

  1.008  RSLT         =

  1.009  IF           PSUBI("4000B")
  1.010  HEAD         {ABSOLUTE AMPLITUDE ACCURACY}
  1.011  ELSE
  1.012  HEAD         {LEVEL MEASUREMENT UNCERTAINTY}
  1.013  ENDIF

  1.014  TARGET
  1.015  HEAD         -2 [7][D250][7][D250][7][D250][7][D250][7]
  1.016  HEAD         -2 Power Sensor Zero and Cal
  1.017  MATH         @Connected = ""
  1.018  PIC          epm_a_100mw_rf_sensor_zero.png
  1.019  EPM          Zero_and_Cal; PowerSensorA = E9304A
  1.020  HEAD         -2

  1.021  CALL         Sub Output Off /SWPG
  1.022  MATH         @Connection = "mdo4000_splitter_epm_swpg"
  1.023  CALL         Sub Tek MDO4000 Check and Display Connection

  1.024  VISA         *CLS;*RST;*OPC?[I!]
  1.025  VISA         ACQUIRE:STATE OFF;STOPAFTER SEQUENCE
  1.026  VISA         HEADER OFF;:CLEARM;:SEL:CH1 OFF
  1.027  VISA         SEL:RF_NORM ON;:RF:UNITS DBM
# Configure DUT automatic marker system.
  1.028  VISA         MARKER:PEAK:STATE ON;THR -150;EXCUR 0;MAX 1
  1.029  VISA         MARKER:TYPE ABS
  1.030  CALL         Sub Tek MDO/MSO/DPO Wait for OPC VISA
  1.031  JMPL         END                          @Abort

  1.032  MATH         @Level = "+10 dBm"
  1.033  CALL         Sub Tek MDO4000 (1yr) Lvl Meas Unc Tests VISA /EPM,SWPG

  1.034  MATH         @Level = "0 dBm"
  1.035  CALL         Sub Tek MDO4000 (1yr) Lvl Meas Unc Tests VISA /EPM,SWPG

  1.036  MATH         @Level = "-15 dBm"
  1.037  CALL         Sub Tek MDO4000 (1yr) Lvl Meas Unc Tests VISA /EPM,SWPG

  1.038  LABEL        END
  1.039  MATH         DEL("@Level")
  1.040  HEAD
  1.041  END
